const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Membros_equipeDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const membros_equipe = await db.membros_equipe.create(
      {
        id: data.id || undefined,

        nome: data.nome || null,
        funcao: data.funcao || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await membros_equipe.setEquipe(data.equipe || null, {
      transaction,
    });

    await membros_equipe.setClientes(data.clientes || null, {
      transaction,
    });

    return membros_equipe;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const membros_equipeData = data.map((item, index) => ({
      id: item.id || undefined,

      nome: item.nome || null,
      funcao: item.funcao || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const membros_equipe = await db.membros_equipe.bulkCreate(
      membros_equipeData,
      { transaction },
    );

    // For each item created, replace relation files

    return membros_equipe;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const membros_equipe = await db.membros_equipe.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.nome !== undefined) updatePayload.nome = data.nome;

    if (data.funcao !== undefined) updatePayload.funcao = data.funcao;

    updatePayload.updatedById = currentUser.id;

    await membros_equipe.update(updatePayload, { transaction });

    if (data.equipe !== undefined) {
      await membros_equipe.setEquipe(
        data.equipe,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await membros_equipe.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return membros_equipe;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const membros_equipe = await db.membros_equipe.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of membros_equipe) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of membros_equipe) {
        await record.destroy({ transaction });
      }
    });

    return membros_equipe;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const membros_equipe = await db.membros_equipe.findByPk(id, options);

    await membros_equipe.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await membros_equipe.destroy({
      transaction,
    });

    return membros_equipe;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const membros_equipe = await db.membros_equipe.findOne(
      { where },
      { transaction },
    );

    if (!membros_equipe) {
      return membros_equipe;
    }

    const output = membros_equipe.get({ plain: true });

    output.pessoas_atividade_membro =
      await membros_equipe.getPessoas_atividade_membro({
        transaction,
      });

    output.equipe = await membros_equipe.getEquipe({
      transaction,
    });

    output.clientes = await membros_equipe.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.equipes_trabalho,
        as: 'equipe',

        where: filter.equipe
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.equipe
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  nome_equipe: {
                    [Op.or]: filter.equipe
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.nome) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('membros_equipe', 'nome', filter.nome),
        };
      }

      if (filter.funcao) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('membros_equipe', 'funcao', filter.funcao),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.membros_equipe.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('membros_equipe', 'nome', query),
        ],
      };
    }

    const records = await db.membros_equipe.findAll({
      attributes: ['id', 'nome'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['nome', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.nome,
    }));
  }
};
